#ifndef WTRUNTIME_BYTEORDER_H
#define WTRUNTIME_BYTEORDER_H

#include "config.h"
#include "wtruntime.h"

/* Type that holds a byte-order info. This type must be 1 byte. */
/* Only the value returned by wtr_byteorder() shall be used. */
typedef wt_u8 wt_bo;

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

wt_bo  wtr_byteorder();
wt_u16 wtr_swap16(wt_u16 x);
wt_u32 wtr_swap32(wt_u32 x);
wt_u64 wtr_swap64(wt_u64 x);
wt_u16 wtr_botoh16(wt_u16 x, wt_bo bo);
wt_u32 wtr_botoh32(wt_u32 x, wt_bo bo);
wt_u64 wtr_botoh64(wt_u64 x, wt_bo bo);
wt_u16 wtr_htobo16(wt_u16 x, wt_bo bo);
wt_u32 wtr_htobo32(wt_u32 x, wt_bo bo);
wt_u64 wtr_htobo64(wt_u64 x, wt_bo bo);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* WTRUNTIME_BYTEORDER_H */
